; Emacs Lisp functions used to eliminate the abbreviated 
; references, as supported by styles/xml-in-laml/elucidator/abbreviated-references.scm.
; Applied on the LAML tutorial June 2, 2004.

(defun two-pars ()
  (save-excursion 
    (forward-sexp-robust 2)))

(defun fix-p-star ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(p*" nil t))
    (if sr 
        (progn 
          (search-backward "(p*" nil t)
          (down-list 1)
          (kill-sexp 1)
          (insert "strong-prog-ref")
          (skip-white-space)
          (if (two-pars)
              (progn 
                 (insert "'file ")
                 (forward-sexp 1)
                 (skip-white-space)
                 (insert "'name ")
                 (backward-up-list 1)
                 (forward-sexp 1))
              (progn 
                 (insert "'name ")
                 (backward-up-list 1)
                 (forward-sexp 1)))
          t)
         nil)))

(defun fix-p-stars ()
  (interactive)
  (while (fix-p-star) 'do-nothing))

(defun fix-p-plus ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(p+" nil t))
    (if sr 
        (progn 
          (search-backward "(p+" nil t)
          (down-list 1)
          (kill-sexp 1)
          (insert "weak-prog-ref")
          (skip-white-space)
          (if (two-pars)
              (progn 
                 (insert "'file ")
                 (forward-sexp 1)
                 (skip-white-space)
                 (insert "'name ")
                 (backward-up-list 1)
                 (forward-sexp 1))
              (progn 
                 (insert "'name ")
                 (backward-up-list 1)
                 (forward-sexp 1)))
          t)
         nil)))

(defun fix-p-pluss ()
  (interactive)
  (while (fix-p-plus) 'do-nothing))


(defun fix-pf-star ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(pf*" nil t))
    (if sr
      (progn
         (search-backward "(pf*" nil t)
         (down-list 1)
         (kill-sexp 1)
         (insert "strong-prog-ref 'file")
         t)
      nil)))

(defun fix-pf-stars ()
  (interactive)
  (while (fix-pf-star) 'do-nothing))

(defun fix-pf-plus ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(pf+" nil t))
    (if sr
      (progn
         (search-backward "(pf+" nil t)
         (down-list 1)
         (kill-sexp 1)
         (insert "weak-prog-ref 'file")
         t)
      nil)))

(defun fix-pf-pluss ()
  (interactive)
  (while (fix-pf-plus) 'do-nothing))

(defun fix-p-minus ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(p-" nil t))
    (if sr
      (progn
         (search-backward "(p-" nil t)
         (down-list 1)
         (kill-sexp 1)
         (insert "typographic-prog-ref 'name")
         t)
      nil)))

(defun fix-p-minuss ()
  (interactive)
  (while (fix-p-minus) 'do-nothing))

(defun fix-sm ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(sm " nil t))
    (if sr
      (progn
         (search-backward "(sm " nil t)
         (down-list 1)
         (kill-sexp 1)
         (insert "source-marker 'name")
         t)
      nil)))

(defun fix-sms ()
  (interactive)
  (while (fix-sm) 'do-nothing))

(defun fix-d ()
  (interactive)
  (let ((sr nil))
    (setq sr (search-forward "(d " nil t))
    (if sr
      (progn
         (search-backward "(d " nil t)
         (down-list 1)
         (kill-sexp 1)
         (insert "doc-ref 'name")
         t)
      nil)))

(defun fix-ds ()
  (interactive)
  (while (fix-d) 'do-nothing))

(defun fix-all ()
  (interactive)
  (goto-char (point-min))
  (fix-p-stars)

  (goto-char (point-min))
  (fix-p-pluss)

  (goto-char (point-min))
  (fix-pf-stars)

  (goto-char (point-min))
  (fix-pf-pluss)

  (goto-char (point-min))
  (fix-p-minuss)

  (goto-char (point-min))
  (fix-sms)

  (goto-char (point-min))
  (fix-ds))


 